﻿// 外部ファイル読み込み
include("define.lua");				// 定数
include("game.lua");				// ゲーム画面


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// スクリプトロード時に一度だけ呼び出される
// ・ここで外部デバイスによる入力処理に対応するために、
//   各画面のタッチエリア情報を登録する
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function OnInitSystem()

	// 各画面のタッチオブジェクトの位置とサイズをセット(このスクリプトが対応しているところのみ)
	hdxSysSetTouchArea( TID_GAME_SINGLE_LKEY01,		106,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_LKEY02,		141,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_LKEY03,		170,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_LKEY04,		205,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_LKEY05,		234,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_LKEY06,		269,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_LKEY07,		298,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_LSCR,		27,487,70,70 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RKEY01,		947,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RKEY02,		982,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RKEY03,		1011,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RKEY04,		1046,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RKEY05,		1075,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RKEY06,		1110,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RKEY07,		1139,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_SINGLE_RSCR,		1183,487,70,70 );

	hdxSysSetTouchArea( TID_GAME_DOUBLE_LKEY01,		368,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_LKEY02,		403,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_LKEY03,		432,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_LKEY04,		467,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_LKEY05,		496,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_LKEY06,		531,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_LKEY07,		560,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_LSCR,		289,487,70,70 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RKEY01,		686,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RKEY02,		721,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RKEY03,		750,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RKEY04,		785,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RKEY05,		814,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RKEY06,		849,491,29,46 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RKEY07,		878,492,35,52 );
	hdxSysSetTouchArea( TID_GAME_DOUBLE_RSCR,		918,487,70,70 );

end


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// レーン
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function OnInitLane()
	// ロング用スクラッチアニメーションをロード
	hdxSysLoadAnime( 10, "scratch.hda", 0, 0 );

	// ロング用スクラッチアニメーションをロング中間オブジェとして割り当てる
	hdxSysSetObject( OBJID_SCRATCH_LONGOFF_MIDDLE,	DRAWTYPE_ANIME,	10 );
end


// レーンの描画の前に呼び出されるので、現在のチックを参照してレーン内で定義したアニメのフレーム値を更新する。
function OnUpdateLane( tick,delta )
	// スクラッチのフレームを算出してセット(1小節に4回ゆれる)
	local _tick = tick % (BMS_RESOLUTION / 4);									// 進んだチック数を0～2399に変換
	local _scale = _tick / (BMS_RESOLUTION / 4);								// 0～2399を0.0～1.0に正規化して倍率とする
	local frm = (hdxSysGetAnimeMaxFrame(10)-1) * _scale;							// アニメの最大フレーム数に倍率を掛けることで表示するフレーム番号を算出
	hdxSysCtrlObject( CTRLID_SCRATCH_LONGOFF_MIDDLE,0,TRUE,1.0,0,frm,0,-2 );	// フレーム番号を指定して表示

end


// ワンショット爆発が必要になると呼び出される。
function OnOneshotExplosion( side,lane,sid )
	// 何もしない
end


// ロング系オブジェの開始時に呼び出される。
function OnBeginLong( side,lane,type )
	// 何もしない
end


// ロング系オブジェの終了時に呼び出される。
function OnEndLong( side,lane,type )
	// 何もしない

end




